> For the complete documentation index, see [llms.txt](https://docs.caf.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.caf.io/caf-sdk/ios/standalone-modules/cafsmartauth/builder.md).

# Building the SDK

## Creating a CafSmartAuth SDK instance

To create a `CafSmartAuth` instance, use the `CafBuilder` class. This class provides a set of methods to configure the SDK instance.

### Builder Properties

| Property      | Type   | Description                            | Required |
| ------------- | ------ | -------------------------------------- | :------: |
| `mobileToken` | String | Mobile token provided by the platform. |     ✅    |

### Builder Methods

| Method                     | Type                      | Description                                                                              | Required |
| -------------------------- | ------------------------- | ---------------------------------------------------------------------------------------- | :------: |
| `setStage(_:)`             | `CAFStage`                | Defines the environment stage (e.g., `.prod`, `.beta`). Default is `.prod`.              |     ❌    |
| `setEmailURL(_:)`          | `URL`                     | Sets the email authentication URL. Must use HTTPS protocol.                              |     ❌    |
| `setPhoneURL(_:)`          | `URL`                     | Sets the phone authentication URL. Must use HTTPS protocol.                              |     ❌    |
| `setPlatform(_:)`          | `CafSdkPlatform`          | Sets the platform on which the SDK is running. Default is `.nativeIos`.                  |     ❌    |
| `setLivenessSettings(_:)`  | `CafFaceLivenessSettings` | Sets the face liveness authentication settings.                                          |     ❌    |
| `setThemeConfigurator(_:)` | `CafThemeConfigurator`    | Sets the theme configuration for the SDK. Customize appearance for light and dark modes. |     ❌    |

### Theme Configuration

To customize the appearance of the SDK, use the theme configurator methods. Two structures are used for theme configuration: `CafThemeConfigurator` and `CafTheme`.

#### CafThemeConfigurator

```swift
public struct CafThemeConfigurator {
    public var lightTheme: CafTheme
    public var darkTheme: CafTheme

    public init(lightTheme: CafTheme = CafTheme(),
                darkTheme: CafTheme = CafTheme()) {
        self.lightTheme = lightTheme
        self.darkTheme = darkTheme
    }
}
```

This structure allows you to define separate themes for light and dark modes. Each theme is defined by a CafTheme structure.

```swift
public struct CafTheme {
    public var backgroundColor: UIColor
    public var textColor: UIColor
    public var linkColor: UIColor
    public var boxBorderColor: UIColor
    public var boxFilledBorderColor: UIColor
    public var boxBackgroundColor: UIColor
    public var boxFilledBackgroundColor: UIColor
    public var boxTextColor: UIColor
    public var progressColor: UIColor

    public init(backgroundColor: String = "#FFFFFF",
                textColor: String = "#FF000000",
                linkColor: String = "#004AF7",
                boxBorderColor: String = "#cbcbcb",
                boxFilledBorderColor: String = "#004AF7",
                boxBackgroundColor: String = "#D3D3D3",
                boxFilledBackgroundColor: String = "#D3D3D3",
                boxTextColor: String = "#004AF7",
                progressColor: String = "#004AF7") {
        self.backgroundColor = UIColor(hex: backgroundColor)
        self.textColor = UIColor(hex: textColor)
        self.linkColor = UIColor(hex: linkColor)
        self.boxBorderColor = UIColor(hex: boxBorderColor)
        self.boxFilledBorderColor = UIColor(hex: boxFilledBorderColor)
        self.boxBackgroundColor = UIColor(hex: boxBackgroundColor)
        self.boxFilledBackgroundColor = UIColor(hex: boxFilledBackgroundColor)
        self.boxTextColor = UIColor(hex: boxTextColor)
        self.progressColor = UIColor(hex: progressColor)
    }
}
```

This structure defines various appearance attributes for the SDK. You can customize colors for backgrounds, text, links, borders, and progress indicators by providing hex string values.

### Example

```swift
import CafSmartAuth

let smartAuth: CafSmartAuthSdk?

private func setupCafSmartAuth() {
    smartAuth = CafSmartAuthSdk.CafBuilder(mobileToken: "myMFAToken")
        .setStage(.prod)
        .setEmailURL(URL(string: "https://myEmailUrl.com")) // Not mandatory
        .setPhoneURL(URL(string: "https://myPhoneUrl.com")) // Not mandatory
        .setLivenessSettings(
            CafFaceLivenessSettings(
                faceLivenessToken: "myFaceAuthToken",
                useLoadingScreen: false,
                filter: .lineDrawing
            )
        )
        .setThemeConfigurator(
            CafThemeConfigurator(
                lightTheme: CafTheme(
                    backgroundColor: "#FFFFFF",
                    textColor: "#000000"
                ),
                darkTheme: CafTheme(
                    backgroundColor: "#000000",
                    textColor: "#FFFFFF"
                )
            )
        )
        .build()
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.caf.io/caf-sdk/ios/standalone-modules/cafsmartauth/builder.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
